# author : stephane kattoor
# licensing : BSD

package twitterParseContacts;

use strict;
use warnings;

use base "HTML::Parser";

sub new {
	my $class = shift;
	my $self = bless
		{
			users => {},
			inUserId => 0,
			inOption => 0,
			currentId => '',
			currentValue => '',
		}
		, $class;

	my $res = $self->SUPER::init(@_);
	return $res;
}

sub start {
	my ($self, $tag, $attr, $attrseq, $origtext) = @_;

	if ($tag eq "select") {
		if ($attr->{name} eq "user[id]") {
			$self->{inUserId} = 1;
		}
	} elsif ($tag eq "option") {
		if ($self->{inUserId}) {
			$self->{inOption} = 1;
			$self->{currentId} = $attr->{value};
		}
	}
}

sub text {
	my ($self, $text) = @_;

	if ($self->{inOption}) {
		$self->{currentValue} = $text;
	}
}

sub end {
	my ($self, $tag, $origtext) = @_;

	if ($tag eq "select") {
		if ($self->{inUserId}) {
			$self->{inUserId} = 0;
		}
	} elsif ($tag eq "option") {
		$self->{users}->{$self->{currentValue}} = $self->{currentId};
		$self->{inOption} = 0;
	}
}

sub getContacts {
	my $self = shift;

	return $self->{users};
}

1;
